diff -urN Original_4.4.4_r1/packages/apps/TestApp/src/com/test/MainActivity.java~ AndroidSource/packages/apps/TestApp/src/com/test/MainActivity.java~
--- Original_4.4.4_r1/packages/apps/TestApp/src/com/test/MainActivity.java~	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/TestApp/src/com/test/MainActivity.java~	2016-06-23 19:06:42.000000000 +0900
@@ -0,0 +1,308 @@
+package com.test;
+
+import java.net.InetAddress;
+import java.net.NetworkInterface;
+import java.net.SocketException;
+import java.util.Enumeration;
+
+import android.app.Activity;
+import android.content.Context;
+import android.content.Intent;
+import android.os.Bundle;
+import android.os.SystemVibrator;
+import android.os.Vibrator;
+import android.provider.Settings;
+import android.provider.Settings.SettingNotFoundException;
+import android.service.distribute.Distributor;
+import android.service.remote.RemoteServiceManager;
+import android.text.InputType;
+import android.util.Log;
+import android.view.Menu;
+import android.view.MenuItem;
+import android.view.View;
+import android.view.View.OnClickListener;
+import android.view.WindowManager;
+import android.widget.Button;
+import android.widget.EditText;
+import android.widget.TextView;
+import android.widget.Toast;
+import android.widget.ToggleButton;
+
+import com.test.location.LocationActivity;
+import com.test.recommendation.RecommendationTest;
+import com.test.sensor.ProxiActivity;
+import com.test.sensor.SensorActivity;
+import com.test.touch.TouchActivity;
+
+public class MainActivity extends Activity
+{
+	private Context mContext;
+	
+	RemoteServiceManager rrm;
+	Distributor dis;
+	
+	TextView ip_tv;
+	TextView info_tv;
+	
+	EditText ip_et;
+	
+	ToggleButton server_tg;
+	Button client_btn;
+	Button disconnect_btn;
+	Button location_test_btn;
+//	ToggleButton client_tg;
+	
+	@Override
+	protected void onCreate(Bundle savedInstanceState)
+	{
+		mContext = getApplicationContext();
+		
+		super.onCreate(savedInstanceState);
+		setContentView(R.layout.activity_main);
+		Log.d("ProxiActivity", "product: " + android.os.Build.PRODUCT);
+		getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);
+		
+		rrm = (RemoteServiceManager)getSystemService(Context.REMOTE_SERVICE);
+		dis = (Distributor)getSystemService(Context.DISTRIBUTED_COMPUTING_SERVICE);
+		
+		findViewById(R.id.recommendation_btn).setOnClickListener(mClickListener);
+		findViewById(R.id.vibrate_btn).setOnClickListener(mClickListener);
+		findViewById(R.id.sensor_btn).setOnClickListener(mClickListener);
+		findViewById(R.id.touch_btn).setOnClickListener(mClickListener);
+		findViewById(R.id.test_btn).setOnClickListener(mClickListener);
+		
+		ip_tv = (TextView) findViewById(R.id.ip_tv);
+		ip_tv.setText(getIpAddress());
+		
+		
+		//////////////////////////////////////////
+		/*
+		info_tv = (TextView) findViewById(R.id.info_tv);
+		//info_tv.setText(getIpAddress());
+		
+		ip_et = (EditText) findViewById(R.id.ip_et);
+		ip_et.setText("192.168.0.");
+		ip_et.requestFocus();
+//		ip_et.setInputType(InputType.TYPE_CLASS_NUMBER);
+		
+		server_tg = (ToggleButton)findViewById(R.id.server_tg);
+		server_tg.setOnClickListener(mClickListener);
+		
+		if(Settings.Global.getInt(getContentResolver(), Settings.Global.REMOTE_REQUEST_SERVER_ON, 0) > 0)
+			server_tg.setChecked(true);
+		else
+			server_tg.setChecked(false);
+		*/
+		/////////////////////////////////////////
+		
+		location_test_btn = (Button)findViewById(R.id.location_test);
+		location_test_btn.setOnClickListener(new OnClickListener() {
+            
+            @Override
+            public void onClick(View v) {
+                // TODO Auto-generated method stub
+                for(int a=0;a<3;a++){
+                    rrm.testLocation();
+                    try {
+                        Thread.sleep(10000);
+                    } catch (InterruptedException e) {
+                        // TODO Auto-generated catch block
+                        e.printStackTrace();
+                    }
+                }
+            }
+        });
+		
+		/*
+		client_btn = (Button)findViewById(R.id.client_btn);
+		client_btn.setOnClickListener(new OnClickListener() {
+            
+		    @Override
+		    public void onClick(View v) {
+		        // TODO Auto-generated method stub
+		        rrm.connectToServer(ip_et.getText().toString());
+		        setRemoteRequestClientOn(true);
+		        Toast.makeText(mContext, "connect!", Toast.LENGTH_SHORT).show();
+		        try {
+		            Log.d("TESTAPP", Settings.Global.getInt(mContext.getContentResolver(), "REMOTE_REQUEST_CLIENT_ON")+"");
+		            Log.d("TESTAPP", Settings.Global.getInt(mContext.getContentResolver(), "REMOTE_REQUEST_CLIENT_ON")+"");
+		            Log.d("TESTAPP", Settings.Global.getInt(mContext.getContentResolver(), "REMOTE_REQUEST_CLIENT_ON")+"");
+		        } catch (SettingNotFoundException e) {
+		            // TODO Auto-generated catch block
+		            e.printStackTrace();
+		        }
+		    }
+        });
+        */
+		
+		disconnect_btn = (Button)findViewById(R.id.client_disconnect);
+		disconnect_btn.setOnClickListener(new OnClickListener() {
+            
+            @Override
+            public void onClick(View v) {
+                // TODO Auto-generated method stub
+//                rrm.disconnectToServer();
+                rrm.printServerIPs();
+                setRemoteRequestClientOn(false);
+                Toast.makeText(mContext, "disconnect!", Toast.LENGTH_SHORT).show();
+            }
+        });
+//		client_tg = (ToggleButton)findViewById(R.id.client_tg);
+//		client_tg.setOnClickListener(mClickListener);
+//		
+//		if(Settings.Global.getInt(getContentResolver(), Settings.Global.REMOTE_REQUEST_CLIENT_ON, 0) > 0)
+//			client_tg.setChecked(true);
+//		else
+//			client_tg.setChecked(false);
+	}
+	
+	Button.OnClickListener mClickListener = new View.OnClickListener()
+	{
+		public void onClick(View v)
+		{
+			switch (v.getId())
+			{
+				case R.id.recommendation_btn:
+					/*runOnUiThread(new Runnable()
+					{
+						@Override
+						public void run()
+						{
+							info_tv.setText(new RecommendationTest(
+									mContext).getDevice());
+						}
+					});*/
+					Intent i3 = new Intent(mContext, LocationActivity.class);
+					startActivity(i3);
+					break;
+				case R.id.vibrate_btn:
+					//new VibrateTest(getApplicationContext()).vibrate();
+				    /*Log.d("VibLatency", "test Vibrate");
+					vibrate(200);*/
+					rrm.requestMotionEvents();
+					
+//				    SystemVibrator sv = new SystemVibrator();
+//				    sv.vibrate(100);
+				    
+					break;
+//				case R.id.server_tg:
+//				if(server_tg.isChecked())
+//				{
+//					//rrm.setEnabled(true);
+//					rrm.startServer();
+//					setRemoteRequestServerOn(true);
+//					Toast.makeText(mContext, "startServer!", Toast.LENGTH_SHORT).show();
+//					
+//					//dis.startTaskExecutor();
+//				}
+//				else
+//				{	
+//					//rrm.setEnabled(false);
+//					rrm.stopServer();
+//					setRemoteRequestServerOn(false);
+//					Toast.makeText(mContext, "stopServer!", Toast.LENGTH_SHORT).show();
+//				}
+//					break;
+//				case R.id.client_tg:
+//				if(client_tg.isChecked())
+//				{
+//					//rrm.setEnabled(true);
+//					rrm.connectToServer(ip_et.getText().toString());
+//					setRemoteRequestClientOn(true);
+//					Toast.makeText(mContext, "connect!", Toast.LENGTH_SHORT).show();
+//					
+//					//dis.startJobManager(ip_et.getText().toString());
+//				}
+//				else
+//				{	
+//					//rrm.setEnabled(false);
+//					rrm.disconnectToServer();
+//					setRemoteRequestClientOn(false);
+//					Toast.makeText(mContext, "disconnect!", Toast.LENGTH_SHORT).show();
+//				}
+//					break;
+				case R.id.sensor_btn:
+					Toast.makeText(mContext, "?!!", Toast.LENGTH_SHORT).show();
+					Intent i = new Intent(mContext, SensorActivity.class);
+					startActivity(i);
+					break;
+				case R.id.touch_btn:
+					Toast.makeText(mContext, "?!!", Toast.LENGTH_SHORT).show();
+					Intent i2 = new Intent(mContext, TouchActivity.class);
+					startActivity(i2);
+					break;
+				case R.id.test_btn:
+					//rrm.testOperation();
+					Intent i4 = new Intent(mContext, ProxiActivity.class);
+					startActivity(i4);
+					break;					
+			}
+		}
+	};
+	
+	private String getIpAddress() {
+ 		String ip = "";
+ 		try {
+ 			Enumeration<NetworkInterface> enumNetworkInterfaces = NetworkInterface
+ 					.getNetworkInterfaces();
+ 			while (enumNetworkInterfaces.hasMoreElements()) {
+
+ 				NetworkInterface networkInterface = enumNetworkInterfaces
+ 						.nextElement();
+ 				Enumeration<InetAddress> enumInetAddress = networkInterface
+ 						.getInetAddresses();
+
+ 				while (enumInetAddress.hasMoreElements()) {
+ 					InetAddress inetAddress = enumInetAddress.nextElement();
+
+ 					if (inetAddress.isSiteLocalAddress()) {
+ 						ip += "SiteLocalAddress: "
+ 								+ inetAddress.getHostAddress() + "\n";
+ 					}
+ 				}
+ 			}
+ 		} catch (SocketException e) {
+ 			e.printStackTrace();
+ 			ip += "Sth wrong! " + e.toString() + "\n";
+ 		}
+ 		return ip;
+ 	}
+	
+	private void vibrate(long m)
+	{
+		Vibrator vibrator = (Vibrator)mContext.getSystemService(Context.VIBRATOR_SERVICE);
+		vibrator.vibrate(m);
+	}
+ 
+	private void setRemoteRequestServerOn(boolean enabling)
+	{
+		Settings.Global.putInt(mContext.getContentResolver(), "REMOTE_REQUEST_SERVER_ON", enabling ? 1 : 0);
+	}
+	
+	private void setRemoteRequestClientOn(boolean enabling)
+	{
+		Settings.Global.putInt(mContext.getContentResolver(), "REMOTE_REQUEST_CLIENT_ON", enabling ? 1 : 0);
+	}
+
+	@Override
+	public boolean onCreateOptionsMenu(Menu menu)
+	{
+		// Inflate the menu; this adds items to the action bar if it is present.
+		getMenuInflater().inflate(R.menu.main, menu);
+		return true;
+	}
+
+	@Override
+	public boolean onOptionsItemSelected(MenuItem item)
+	{
+		// Handle action bar item clicks here. The action bar will
+		// automatically handle clicks on the Home/Up button, so long
+		// as you specify a parent activity in AndroidManifest.xml.
+		int id = item.getItemId();
+		if (id == R.id.action_settings)
+		{
+			return true;
+		}
+		return super.onOptionsItemSelected(item);
+	}
+}
diff -urN Original_4.4.4_r1/packages/apps/TestApp/src/com/test/recommendation/RecommendationTest.java AndroidSource/packages/apps/TestApp/src/com/test/recommendation/RecommendationTest.java
--- Original_4.4.4_r1/packages/apps/TestApp/src/com/test/recommendation/RecommendationTest.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/TestApp/src/com/test/recommendation/RecommendationTest.java	2016-03-02 20:44:55.000000000 +0900
@@ -0,0 +1,27 @@
+package com.test.recommendation;
+
+import java.util.List;
+
+import android.service.devicemanager.DeviceManager;
+import android.content.Context;
+
+public class RecommendationTest
+{
+	DeviceManager dsm;
+	List peer;
+	
+	public RecommendationTest(Context ctx)
+	{
+		dsm = (DeviceManager)ctx.getSystemService(Context.DEVICE_MANAGEMENT_SERVICE);
+	}
+	
+	public String getDevice()
+	{
+		peer=dsm.getDeviceList(1);
+		
+		if(peer.isEmpty())
+			return "no peer";
+		else
+			return "ip:"+ dsm.recommendDevice(peer) + "length:" + peer.size();
+	}
+}
diff -urN Original_4.4.4_r1/packages/apps/TestApp/src/com/test/sensor/Particle.java AndroidSource/packages/apps/TestApp/src/com/test/sensor/Particle.java
--- Original_4.4.4_r1/packages/apps/TestApp/src/com/test/sensor/Particle.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/TestApp/src/com/test/sensor/Particle.java	2015-01-09 00:26:11.000000000 +0900
@@ -0,0 +1,38 @@
+package com.test.sensor;
+
+public class Particle
+{
+	/* coefficient of restitution */
+    private static final float COR = 0.7f;
+     
+    public float mPosX;
+    public float mPosY;
+    private float mVelX;
+    private float mVelY;
+     
+    public void updatePosition(float sx, float sy, float sz, long timestamp) {
+        float dt = (System.nanoTime() - timestamp) / 1000000000.0f;
+        mVelX += -sx * dt;
+        mVelY += -sy * dt;
+         
+        mPosX += mVelX * dt;
+        mPosY += mVelY * dt;
+    }
+     
+    public void resolveCollisionWithBounds(float mHorizontalBound, float mVerticalBound) {
+        if (mPosX > mHorizontalBound) {
+            mPosX = mHorizontalBound;
+            mVelX = -mVelX * COR;
+        } else if (mPosX < -mHorizontalBound) {
+            mPosX = -mHorizontalBound;
+            mVelX = -mVelX * COR;
+        }
+        if (mPosY > mVerticalBound) {
+            mPosY = mVerticalBound;
+            mVelY = -mVelY * COR;
+        } else if (mPosY < -mVerticalBound) {
+            mPosY = -mVerticalBound;
+            mVelY = -mVelY * COR;
+        }
+    }
+}
diff -urN Original_4.4.4_r1/packages/apps/TestApp/src/com/test/sensor/SensorActivity.java AndroidSource/packages/apps/TestApp/src/com/test/sensor/SensorActivity.java
--- Original_4.4.4_r1/packages/apps/TestApp/src/com/test/sensor/SensorActivity.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/TestApp/src/com/test/sensor/SensorActivity.java	2016-09-23 17:26:52.381025348 +0900
@@ -0,0 +1,140 @@
+package com.test.sensor;
+
+import android.app.Activity;
+import android.content.Context;
+import android.hardware.Sensor;
+import android.hardware.SensorEvent;
+import android.hardware.SensorEventListener;
+import android.hardware.SensorManager;
+import android.os.Bundle;
+import android.service.remote.RemoteServiceManager;
+import android.util.Log;
+import android.view.View;
+import android.view.View.OnClickListener;
+import android.view.animation.Animation;
+import android.view.animation.RotateAnimation;
+import android.widget.Button;
+import android.widget.ImageView;
+import android.widget.TextView;
+
+import com.test.R;
+
+public class SensorActivity extends Activity implements SensorEventListener {
+
+    // define the display assembly compass picture
+    private ImageView image;
+
+    // record the compass picture angle turned
+    private float currentDegree = 0f;
+
+    // device sensor manager
+    private SensorManager mSensorManager;
+    private RemoteServiceManager mRemoteManager;
+
+    TextView tvHeading;
+
+	private final String nexus5 = "aosp_hammerhead";
+	private final String nexus7 = "aosp_deb";
+    
+    @Override
+    protected void onCreate(Bundle savedInstanceState) {
+        super.onCreate(savedInstanceState);
+        setContentView(R.layout.activity_sensor);
+
+        // 
+        image = (ImageView) findViewById(R.id.imageViewCompass);
+
+        // TextView that will tell the user what degree is he heading
+        tvHeading = (TextView) findViewById(R.id.tvHeading);
+
+        // initialize your android device sensor capabilities
+        mSensorManager = (SensorManager) getSystemService(SENSOR_SERVICE);
+        
+        mRemoteManager = (RemoteServiceManager) getSystemService(Context.REMOTE_SERVICE);
+        
+        Button test_btn = (Button) findViewById(R.id.test_btn);
+        test_btn.setOnClickListener(new OnClickListener()
+		{
+			
+			@Override
+			public void onClick(View v)
+			{
+				mRemoteManager.testSensor();
+			}
+		});
+    }
+
+    @Override
+    protected void onResume() {
+        super.onResume();
+
+        //for the system's orientation sensor registered listeners
+        String device = android.os.Build.PRODUCT;
+        if (device.equalsIgnoreCase(nexus7)) {
+        	Log.d("APP", device);
+            mSensorManager.registerListener(this,
+                    mSensorManager.getDefaultSensor(Sensor.TYPE_ORIENTATION),
+                    SensorManager.SENSOR_DELAY_NORMAL);
+        } else if (device.equalsIgnoreCase(nexus5)) {
+        	Log.d("APP", device);
+            mSensorManager.registerListener(this,
+                    mSensorManager.getDefaultSensor(Sensor.TYPE_ORIENTATION),
+                    SensorManager.SENSOR_DELAY_NORMAL);
+        }
+        
+    }
+
+    @Override
+    protected void onPause() {
+        super.onPause();
+        // to stop the listener and save battery
+        mSensorManager.unregisterListener(this);
+    }
+
+    @Override
+    public void onSensorChanged(SensorEvent event) {
+
+    	//Thread.dumpStack();
+        // get the angle around the z-axis rotated
+    	
+//    	Log.d("SensorLatency", event.values[0] + "\t" + System.currentTimeMillis());
+        if(event.sourceDevice==1){
+            Log.d("SensorLatency", "source device: " + event.sourceDevice);            
+        }
+    	
+    	
+        float degree = Math.round(event.values[0]);
+
+        tvHeading.setText("Heading: " + Float.toString(degree) + " degrees");
+
+        // create a rotation animation (reverse turn degree degrees)
+        RotateAnimation ra = new RotateAnimation(
+                currentDegree, 
+                -degree,
+                Animation.RELATIVE_TO_SELF, 0.5f, 
+                Animation.RELATIVE_TO_SELF,
+                0.5f);
+
+        // how long the animation will take place
+        ra.setDuration(210);
+
+        // set the animation after the end of the reservation status
+        ra.setFillAfter(true);
+
+        // Start the animation
+        image.startAnimation(ra);
+        currentDegree = -degree;
+
+    }
+
+    @Override
+    public void onAccuracyChanged(Sensor sensor, int accuracy) {
+        // not in use
+    }
+    
+    @Override
+    public void onDestroy(){
+    	super.onDestroy();
+    	mSensorManager.unregisterListener(this);
+    }
+}
\ No newline at end of file
diff -urN Original_4.4.4_r1/packages/apps/TestApp/src/com/test/sensor/SimulationView.java AndroidSource/packages/apps/TestApp/src/com/test/sensor/SimulationView.java
--- Original_4.4.4_r1/packages/apps/TestApp/src/com/test/sensor/SimulationView.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/TestApp/src/com/test/sensor/SimulationView.java	2015-01-09 00:26:11.000000000 +0900
@@ -0,0 +1,129 @@
+package com.test.sensor;
+
+import android.content.Context;
+import android.graphics.Bitmap;
+import android.graphics.BitmapFactory;
+import android.graphics.BitmapFactory.Options;
+import android.graphics.Canvas;
+import android.hardware.Sensor;
+import android.hardware.SensorEvent;
+import android.hardware.SensorEventListener;
+import android.hardware.SensorManager;
+import android.view.Display;
+import android.view.Surface;
+import android.view.View;
+import android.view.WindowManager;
+
+import com.test.R;
+
+public class SimulationView extends View implements SensorEventListener {
+	 
+    private SensorManager mSensorManager;
+    private Sensor mAccelerometer;
+    private Display mDisplay;   
+     
+    private Bitmap mGrass;
+    private Bitmap mHole;
+    private Bitmap mBitmap;
+    private static final int BALL_SIZE = 32;
+    private static final int HOLE_SIZE = 40;
+     
+    private float mXOrigin;
+    private float mYOrigin;
+    private float mHorizontalBound;
+    private float mVerticalBound;
+     
+    public SimulationView(Context context) {
+        super(context);
+         
+        Bitmap ball = BitmapFactory.decodeResource(getResources(), R.drawable.ball);
+        mBitmap = Bitmap.createScaledBitmap(ball, BALL_SIZE, BALL_SIZE, true);
+         
+        Bitmap hole = BitmapFactory.decodeResource(getResources(), R.drawable.hole);
+        mHole = Bitmap.createScaledBitmap(hole, HOLE_SIZE, HOLE_SIZE, true);
+         
+        Options opts = new Options();
+        opts.inDither = true;
+        opts.inPreferredConfig = Bitmap.Config.RGB_565;
+        mGrass = BitmapFactory.decodeResource(getResources(), R.drawable.grass, opts);
+        
+        WindowManager mWindowManager = (WindowManager) context.getSystemService(Context.WINDOW_SERVICE);
+        mDisplay = mWindowManager.getDefaultDisplay();
+         
+        mSensorManager = (SensorManager) context.getSystemService(Context.SENSOR_SERVICE);
+        mAccelerometer = mSensorManager.getDefaultSensor(Sensor.TYPE_ACCELEROMETER);
+    }
+ 
+    @Override
+    protected void onSizeChanged(int w, int h, int oldw, int oldh) {
+        mXOrigin = w * 0.5f;
+        mYOrigin = h * 0.5f;
+         
+        mHorizontalBound = (w - BALL_SIZE) * 0.5f;
+        mVerticalBound = (h - BALL_SIZE) * 0.5f;
+    }
+    
+    private float mSensorX;
+    private float mSensorY;
+    private float mSensorZ;
+    private long mSensorTimeStamp;
+     
+    @Override
+    public void onSensorChanged(SensorEvent event) {
+        if (event.sensor.getType() != Sensor.TYPE_ACCELEROMETER)
+            return;
+         
+        switch (mDisplay.getRotation()) {
+        case Surface.ROTATION_0:
+            mSensorX = event.values[0];
+            mSensorY = event.values[1];
+            break;
+        case Surface.ROTATION_90:
+            mSensorX = -event.values[1];
+            mSensorY = event.values[0];
+            break;
+        case Surface.ROTATION_180:
+            mSensorX = -event.values[0];
+            mSensorY = -event.values[1];
+            break;
+        case Surface.ROTATION_270:
+            mSensorX = event.values[1];
+            mSensorY = -event.values[0];
+            break;
+        }
+        mSensorZ = event.values[2];
+        mSensorTimeStamp = event.timestamp;
+    }
+     
+    @Override
+    public void onAccuracyChanged(Sensor sensor, int accuracy) {
+     
+    }
+    
+    public void startSimulation() {
+        mSensorManager.registerListener(this, mAccelerometer, SensorManager.SENSOR_DELAY_UI);
+    }
+     
+    public void stopSimulation() {
+        mSensorManager.unregisterListener(this);
+    }
+    
+    private Particle mBall = new Particle();
+    
+    @Override
+    protected void onDraw(Canvas canvas) {
+        super.onDraw(canvas);
+         
+        canvas.drawBitmap(mGrass, 0, 0, null);
+        canvas.drawBitmap(mHole, mXOrigin - HOLE_SIZE/2, mYOrigin - HOLE_SIZE/2, null);
+     
+        mBall.updatePosition(mSensorX, mSensorY, mSensorZ, mSensorTimeStamp);
+        mBall.resolveCollisionWithBounds(mHorizontalBound, mVerticalBound);
+     
+        canvas.drawBitmap(mBitmap, 
+                            (mXOrigin - BALL_SIZE/2) + mBall.mPosX, 
+                            (mYOrigin - BALL_SIZE/2) - mBall.mPosY, null);
+         
+        invalidate();
+    }
+}
\ No newline at end of file
diff -urN Original_4.4.4_r1/packages/apps/TestApp/src/com/test/service/VibrateTest.java AndroidSource/packages/apps/TestApp/src/com/test/service/VibrateTest.java
--- Original_4.4.4_r1/packages/apps/TestApp/src/com/test/service/VibrateTest.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/TestApp/src/com/test/service/VibrateTest.java	2015-01-09 00:26:11.000000000 +0900
@@ -0,0 +1,19 @@
+package com.test.service;
+
+import android.content.Context;
+import android.os.Vibrator;
+
+public class VibrateTest
+{
+	private Vibrator vibrator;
+	
+	public VibrateTest(Context ctx)
+	{
+		vibrator = (Vibrator)ctx.getSystemService(Context.VIBRATOR_SERVICE);
+	}
+	
+	public void vibrate()
+	{
+		vibrator.vibrate(100);
+	}
+}
diff -urN Original_4.4.4_r1/packages/apps/TestApp/src/com/test/touch/SingleTouchEventView.java AndroidSource/packages/apps/TestApp/src/com/test/touch/SingleTouchEventView.java
--- Original_4.4.4_r1/packages/apps/TestApp/src/com/test/touch/SingleTouchEventView.java	1970-01-01 09:00:00.000000000 +0900
+++ AndroidSource/packages/apps/TestApp/src/com/test/touch/SingleTouchEventView.java	2016-09-23 16:39:01.473117957 +0900
@@ -0,0 +1,150 @@
+package com.test.touch;
+
+import java.util.ArrayList;
+
+import android.content.Context;
+import android.graphics.Canvas;
+import android.graphics.Color;
+import android.graphics.Paint;
+import android.graphics.Path;
+import android.util.AttributeSet;
+import android.util.Log;
+import android.util.Pair;
+import android.view.MotionEvent;
+import android.view.View;
+import android.widget.Button;
+
+public class SingleTouchEventView extends View {
+		
+	private Canvas      m_Canvas;
+
+    private Path        m_Path;
+
+    private Paint       m_Paint;
+
+    ArrayList<Pair<Path, Paint>> paths = new ArrayList<Pair<Path, Paint>>();
+
+    ArrayList<Pair<Path, Paint>> undonePaths = new ArrayList<Pair<Path, Paint>>(); 
+
+    private float mX, mY;
+
+    private static final float TOUCH_TOLERANCE = 4;
+
+  public SingleTouchEventView(Context context, AttributeSet attrs) {
+    super(context, attrs);
+    
+    m_Paint = new Paint();
+    m_Paint.setAntiAlias(true);
+    m_Paint.setDither(true);
+    m_Paint.setColor(Color.parseColor("#37A1D1"));
+    m_Paint.setStyle(Paint.Style.STROKE);
+    m_Paint.setStrokeJoin(Paint.Join.ROUND);
+    m_Paint.setStrokeCap(Paint.Cap.ROUND);
+    m_Paint.setStrokeWidth(2);      
+
+    m_Canvas = new Canvas();
+
+    m_Path = new Path();
+    Paint newPaint = new Paint(m_Paint);
+    paths.add(new Pair<Path, Paint>(m_Path, newPaint));
+  }
+
+  @Override
+  protected void onDraw(Canvas canvas) {
+	  for (Pair<Path, Paint> p : paths) 
+      {
+          canvas.drawPath(p.first, p.second);
+      }
+  }
+
+  @Override
+  public boolean onTouchEvent(MotionEvent event) {
+	 
+    float x = event.getX();
+    float y = event.getY();
+
+//    Log.d("APP", x + "," + y + "\t" + System.currentTimeMillis());
+    
+    
+//    Log.d("TouchLatency", x + " " + y + ",,,"+ "\nsource device: " + event.getSourceDevice()
+//    		+ "\naction: " + event.getAction());
+    
+    Log.d("TouchLatency", "source device: " + event.getSourceDevice());
+    
+    
+//    Log.d("APP", event.getMetaState()+"");
+    
+//        Log.d("APP", x + "," + y + "\t" + System.currentTimeMillis());
+    
+    
+    switch (event.getAction()) 
+    {
+        case MotionEvent.ACTION_DOWN:
+        	if(event.getSourceDevice() == 0)
+            {
+            	 m_Paint.setColor(Color.BLACK);
+
+                 Paint newPaint = new Paint(m_Paint); // Clones the mPaint object
+                 paths.add(new Pair<Path, Paint>(m_Path, newPaint));
+            }
+            else if(event.getSourceDevice() == 1)
+            {
+            	 m_Paint.setColor(Color.RED);
+
+                 Paint newPaint = new Paint(m_Paint); // Clones the mPaint object
+                 paths.add(new Pair<Path, Paint>(m_Path, newPaint));
+            }
+            else
+            {
+            	 m_Paint.setColor(Color.GREEN);
+
+                 Paint newPaint = new Paint(m_Paint); // Clones the mPaint object
+                 paths.add(new Pair<Path, Paint>(m_Path, newPaint));
+            }
+        touch_start(x, y);
+        invalidate();
+        break;
+        case MotionEvent.ACTION_MOVE:
+        touch_move(x, y);
+        invalidate();
+        break;
+        case MotionEvent.ACTION_UP:
+        touch_up();
+        invalidate();
+        break;
+    }
+    return true;
+  }
+  
+  private void touch_start(float x, float y) 
+  {
+      m_Path.reset();
+      m_Path.moveTo(x, y);
+      mX = x;
+      mY = y;
+  }
+
+  private void touch_move(float x, float y) 
+  {
+      float dx = Math.abs(x - mX);
+      float dy = Math.abs(y - mY);
+      if (dx >= TOUCH_TOLERANCE || dy >= TOUCH_TOLERANCE) 
+      {
+          m_Path.quadTo(mX, mY, (x + mX)/2, (y + mY)/2);
+          mX = x;
+          mY = y;
+      }
+  }
+  private void touch_up() 
+  {
+      m_Path.lineTo(mX, mY);
+
+      // commit the path to our offscreen
+      m_Canvas.drawPath(m_Path, m_Paint);
+
+      // kill this so we don't double draw            
+      m_Path = new Path();
+      Paint newPaint = new Paint(m_Paint); // Clones the mPaint object
+      paths.add(new Pair<Path, Paint>(m_Path, newPaint));
+  }
+} 
